﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Data.Entity;
using System.Configuration;
using System.Data.Entity.ModelConfiguration;

namespace MvcSampleApp.Models
{
    public class BlogContext : DbContext
    {
        public BlogContext()
        {
            this.Database.Connection.ConnectionString =
                    ConfigurationManager.ConnectionStrings["BlogsConnectionString"]
                    .ConnectionString;
        }
        public DbSet<BlogCategory> Categories { get; set; }
        public DbSet<BlogEntry> Entries { get; set; }

        protected override void OnModelCreating(System.Data.Entity.ModelConfiguration.ModelBuilder modelBuilder)
        {
            base.OnModelCreating(modelBuilder);


            modelBuilder.Entity<BlogEntry>().HasKey(a => a.BlogEntryId);
            modelBuilder.Entity<BlogCategory>().HasKey(a => a.CategoryId);
            modelBuilder.Entity<BlogEntry>().HasRequired(e => e.Category).WithMany().WillCascadeOnDelete(false);
        }

        public void SetAsModified(object entry)
        {
            this.ObjectContext.ObjectStateManager.ChangeObjectState(entry, System.Data.EntityState.Modified);
        }

        public void SetAsUnchanged(object entry)
        {
            this.ObjectContext.ObjectStateManager.ChangeObjectState(entry, System.Data.EntityState.Unchanged);
        }
    }
}