﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.ComponentModel.DataAnnotations;

namespace MvcSampleApp.Models
{
    public class BlogEntry
    {
        [Key]
        public int BlogEntryId { get; set; }

        [Display(Name = "Title")]
        [StringLength(30, MinimumLength = 5)]
        [Required]
        public string Title { get; set; }

        [Display(Name = "Post Text")]
        [StringLength(int.MaxValue)]
        [Required]
        public string PostText { get; set; }

        [Display(Name = "Category")]
        public virtual BlogCategory Category { get; set; }

        [Display(Name = "Post Date")]
        [Range(typeof(DateTime), "1/1/1900", "12/31/2099", ErrorMessage="Date must be between 1/1/1900 and 12/31/2099")]
        [DisplayFormat(ApplyFormatInEditMode = true, DataFormatString = "{0:MM/dd/YYYY}")]
        [Required]
        public DateTime? PostedOn { get; set; }

        public IEnumerable<BlogCategory> Categories { get; set; }

        [Range(1, int.MaxValue, ErrorMessage = "Caregory is required")]
        [Display(Name = "Category")]
        public int CategoryID { get; set; }


    }
}